import _extends from "@babel/runtime/helpers/esm/extends";
var customMarksFactory = function customMarksFactory(_ref) {
  var marks = _ref.marks,
    max = _ref.max,
    min = _ref.min,
    step = _ref.step,
    ticks = _ref.ticks;
  var steps = Array.from(Array(ticks), function (x, index) {
    return index * step + min;
  });
  var markRange = Math.round((max - min) / (marks.length - 1));
  var idx = 0;
  return steps.reduce(function (acc, step) {
    if (step === min || step % (markRange + min) === 0) {
      acc[step] = marks[idx++];
    } else {
      acc[step] = '';
    }
    return acc;
  }, {});
};
var linearMarksFactory = function linearMarksFactory(_ref2) {
  var _ref3;
  var step = _ref2.step,
    min = _ref2.min,
    max = _ref2.max,
    ticks = _ref2.ticks;
  var steps = Array.from(Array(ticks), function (x, index) {
    return index * step;
  });
  return step === 1 ? (_ref3 = {}, _ref3[min] = min, _ref3[max] = max, _ref3) : steps.reduce(function (marksConfig, step) {
    marksConfig[step] = step;
    return marksConfig;
  }, {});
};
var fullWidthMarksFactory = function fullWidthMarksFactory(marks) {
  var _extends2;
  var marksKeys = Object.keys(marks);
  var firstMarkKey = marksKeys[0];
  var lastMarkKey = marksKeys[marksKeys.length - 1];
  var nextMarks = _extends({}, marks, (_extends2 = {}, _extends2[firstMarkKey] = {
    label: marks[firstMarkKey],
    style: {
      transform: 'inherit'
    }
  }, _extends2[lastMarkKey] = {
    label: marks[lastMarkKey],
    style: {
      transform: 'inherit',
      left: 'auto',
      right: '0'
    }
  }, _extends2));
  return nextMarks;
};
var markerFactory = function markerFactory(_ref4) {
  var step = _ref4.step,
    min = _ref4.min,
    max = _ref4.max,
    marks = _ref4.marks,
    isFullWidth = _ref4.isFullWidth;
  var ticks = Math.round((max - min) / step) + 1;
  var nextMarks = marks ? customMarksFactory({
    marks: marks,
    min: min,
    max: max,
    step: step,
    ticks: ticks
  }) : linearMarksFactory({
    step: step,
    min: min,
    max: max,
    ticks: ticks
  });
  return isFullWidth ? fullWidthMarksFactory(nextMarks) : nextMarks;
};
export default markerFactory;